<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama pengguna, no. handphone" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                    <el-button @click="showFilterDialog = true" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-funnel"></i> Filter
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'user', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Pengguna
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="users" ref="userTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Pengguna"
                width="250">
                <template slot-scope="scope">
                    <div v-if="scope.row.profile.media != null">
                        <img :src="scope.row.profile.media.url.small" width="24" class="img-circle" style="float:left;margin-right:10px;">
                        <span style="color:#3E89FA;display:inline-block;">{{ scope.row.profile.fullname }}</span>
                    </div>
                    <div v-else>
                        <div :data-initial-small="scope.row.profile.initial" style="float:left;margin-right:10px;"></div>
                        <span style="color:#3E89FA;margin-top:10px;display:inline-block;">{{ scope.row.profile.fullname }}</span>
                    </div>					
                </template>
            </el-table-column>
            <el-table-column
                label="Handphone"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.phone }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Role"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.role.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Online"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.isonline == 0" type="info" size="mini">&#9632; Offline</el-tag>
                    <el-tag v-else type="success" size="mini">&#9632; Online</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Status"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.status == 'inactive'" type="info" size="mini">Tidak Aktif</el-tag>
                    <el-tag v-else-if="scope.row.status == 'active'" type="success" size="mini">Aktif</el-tag>
                    <el-tag v-else type="danger" size="mini">Ditangguhkan</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Sub Akun Dari"
                width="150"
                v-if="me.role.slug == 'root'">
                <template slot-scope="{row}">
                    <span v-if="row.parents">{{ row.parents.profile.fullname }}</span>
                    <span v-else>-</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'user', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'user', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="filterLoading" title="Filter" :visible.sync="showFilterDialog" width="30%" :show-close="false" @closed="resetForm">
            <aside>
                <el-alert type="info" description="Tampilkan data pengguna berdasarkan kriteria di bawah" :closable=false show-icon></el-alert>
            </aside>
            <el-form ref="filter" :model="filter">
                <el-form-item label="Kata Kunci" prop="keyword">
                    <el-input ref="keyword" name="keyword" v-model="filter.keyword" placeholder="No. laporan, judul" autocomplete="off" maxlength="255" clearable></el-input>
                </el-form-item>
                <el-form-item label="Status Akun" prop="status">
                    <el-select v-model="filter.status" placeholder="Pilih status" class="width-100" ref="status" name="status" clearable>
                        <el-option
                            v-for="item in status"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="Role" prop="role" v-if="me.role.slug == 'root' || userForm.id != me.id">
                    <el-select
                        ref="role"
                        name="role"
                        class="width-100"
                        v-model="filter.role"
                        value-key="id"
                        placeholder="Pilih Role"
                        no-data-text="No Data"
                        clearable>
                        <el-option
                            v-for="item in userRoles"
                            :key="item.id"
                            :label="item.name"
                            :value="item.id">                        
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="Sub Akun Dari" prop="parent" v-if="me.role.slug == 'root'">
                    <el-select
                        ref="parent"
                        name="parent"
                        class="width-100"
                        v-model="filter.parent"
                        placeholder="Pilih Akun"
                        no-data-text="No Data"
                        clearable
                        filterable
                        remote
                        :remote-method="getParents"
                        value-key="id">
                        <el-option
                            v-for="item in parents"
                            :key="item.id"
                            :label="item.profile.fullname"
                            :value="item.id">   
                            <span style="float: left">{{ item.profile.fullname }}</span>
                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>                     
                        </el-option>
                    </el-select>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showFilterDialog = false" size="medium">Batal</el-button>
                <el-button @click="handleSearch" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> Submit
                </el-button>
            </span>
        </el-dialog>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="45%" :show-close="false" @closed="resetForm">
            <el-form ref="userForm" :model="userForm" :rules="userRules">
                <aside>
                    <el-alert type="info" description="Menampilkan semua daftar pengguna yang dimiliki oleh akun dengan role pemilik (owner)." :closable=false show-icon></el-alert>
                </aside> 
                <el-tabs v-model="activeTab">
                    <el-tab-pane name="profile">
                        <span slot="label"><i class="ion-ios-square" style="color:#C8B2F4;"></i> Profil &amp; Akun</span>
                        <el-upload
                            class="avatar-uploader"
                            :action="uploadURL"
                            name="media"
                            with-credentials
                            accept=" .jpg, .jpeg, .png"
                            :headers="{'Authorization': 'Bearer ' + token.access_token}"
                            :limit=1
                            :on-success="handleAvatarSuccess"
                            :before-upload="beforeAvatarUpload"
                            :on-remove="handleRemove">
                            <img v-if="userForm.mediaURL" :src="userForm.mediaURL" class="avatar">
                            <i v-else class="el-icon-plus avatar-uploader-icon"></i>
                        </el-upload>
                        <h3>Profil Pengguna</h3>
                        <el-row :gutter="20">
                            <el-col :lg="8" :md="24" :sm="24">
                                <el-form-item label="Jenis Kelamin" prop="gender">
                                    <el-radio-group ref="gender" name="gender" v-model="userForm.gender">
                                        <el-radio label="m">Laki-Laki</el-radio>
                                        <el-radio label="f">Perempuan</el-radio>
                                    </el-radio-group>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="8" :md="24" :sm="24">
                                <el-form-item label="Tanggal Lahir" prop="birthday" class="width-100">
                                    <el-date-picker v-model="userForm.birthday" ref="birthday" name="birthday" type="date" :default-value="userForm.birthday" format="dd-MM-yyyy" value-format="yyyy-MM-dd" :clearable="false" :editable="false"></el-date-picker>    
                                </el-form-item>
                            </el-col>
                            <el-col :lg="8" :md="24" :sm="24">
                                <el-form-item label="Status Di Keluarga" prop="relationship_status">
                                    <el-select v-model="userForm.relationship_status" placeholder="Pilih status" class="width-100" ref="relationship_status" name="relationship_status">
                                        <el-option
                                            v-for="item in relationshipStatus"
                                            :key="item.value"
                                            :label="item.label"
                                            :value="item.value">
                                        </el-option>
                                    </el-select>
                                </el-form-item>                        
                            </el-col>
                        </el-row>                       

                        <el-row :gutter="20">
                            <el-col :lg="14" :md="24" :sm="24">
                                <el-form-item label="Nama Lengkap" prop="fullname">
                                    <el-input ref="fullname" name="fullname" v-model="userForm.fullname" placeholder="Masukkan nama lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="10" :md="24" :sm="24">
                                <el-form-item label="No. Handphone" prop="phone">
                                    <el-input type="number" ref="phone" name="phone" v-model="userForm.phone" placeholder="No. Handphone aktif" autocomplete="off" maxlength="25"></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>
                        <el-form-item label="Identitas" prop="idcard_number">
                            <el-input type="number" placeholder="No. Identitas" v-model="userForm.idcard_number" class="input-with-select" ref="idcard_number" name="idcard_number" :disabled="userForm.idcard == ''">
                                <el-select v-model="userForm.idcard" ref="idcard" name="idcard" slot="prepend" placeholder="Jenis Kartu Identitas" style="width:200px;">
                                    <el-option label="KTP" value="ktp"></el-option>
                                    <el-option label="SIM" value="sim"></el-option>
                                    <el-option label="Paspor" value="paspor"></el-option>
                                    <el-option label="Badge" value="badge"></el-option>
                                </el-select>
                            </el-input>
                        </el-form-item>                
                        <el-row :gutter="20">
                            <el-col :lg="16" :md="24" :sm="24">
                                <el-form-item label="Alamat" prop="address">
                                    <el-input ref="address" name="address" v-model="userForm.address" placeholder="Alamat lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="8" :md="24" :sm="24">
                                <el-form-item label="Kode Pos" prop="profile_region_id">
                                    <el-select
                                        ref="profile_region_id"
                                        name="profile_region_id"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getRegions"
                                        v-model="userForm.profile_region_id"
                                        value-key="id"
                                        placeholder="Ketik kode pos"
                                        no-data-text="No Data"
                                        :loading="profileRegionLoading">
                                        <el-option
                                            v-for="item in regions"
                                            :key="item.id"
                                            :label="item.name+' ('+item.postal+')'"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.name }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ getAdministrative(item) }}</strong>
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>                    
                        </el-row>
                        <el-form-item label="" prop="showMap">
                            <el-checkbox v-model="showMap">Detil Lokasi</el-checkbox>
                        </el-form-item>
                        <GmapMap 
                            id="map"
                            v-if="showMap == true" 
                            ref="mapRef"
                            :options="{
                                zoomControl: true,
                                mapTypeControl: false,
                                scaleControl: false,
                                streetViewControl: false,
                                rotateControl: false,
                                fullscreenControl: true,
                                disableDefaultUi: false
                            }"
                            :zoom="map.zoom"
                            :center="map.center">
                            <GmapMarker ref="markerRef" :position="map.center" :draggable="true" @dragend="handleMoveMarker($event)"/>
                        </GmapMap>
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="24" :sm="24">
                            <el-form-item label="Status Kepemilikan Rumah" prop="residential_status">
                                    <el-select v-model="userForm.residential_status" placeholder="Pilih status" class="width-100" ref="residential_status" name="residential_status">
                                        <el-option
                                            v-for="item in residentialStatus"
                                            :key="item.value"
                                            :label="item.label"
                                            :value="item.value">
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="24" :sm="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                                <el-form-item label="Warga Perumahan">
                                    <el-select v-model="userForm.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                        <el-option
                                            v-for="item in residentials"
                                            :key="item.id"
                                            :label="item.name"
                                            :value="item.id">
                                            <span style="float: left">{{ item.name }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.region[0] }}</strong>
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                        </el-row>
                        <div v-if="userForm.residential_status == 'rent'">
                            <h3>Data Pemilik</h3>
                            <el-row :gutter="20">
                                <el-col :lg="12" :md="24" :sm="24">
                                    <el-form-item label="Nama Pemilik" prop="landlord">
                                        <el-input ref="landlord" name="landlord" v-model="userForm.landlord" placeholder="Masukkan nama pemilik rumah" autocomplete="off" maxlength="255" show-word-limit></el-input>
                                    </el-form-item>
                                </el-col>
                                <el-col :lg="12" :md="24" :sm="24">
                                    <el-form-item label="No. Handphone Pemilik" prop="landlord_phone">
                                        <el-input type="number" ref="landlord_phone" name="landlord_phone" v-model="userForm.phone" placeholder="No. Handphone aktif" autocomplete="off" maxlength="25"></el-input>
                                    </el-form-item>
                                </el-col>
                            </el-row>
                            <el-row :gutter="20">
                                <el-col :lg="16" :md="24" :sm="24">
                                    <el-form-item label="Alamat Pemilik" prop="landlord_address">
                                        <el-input ref="landlord_address" name="landlord_address" v-model="userForm.address" placeholder="Alamat lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                                    </el-form-item>
                                </el-col>
                                <el-col :lg="8" :md="24" :sm="24">
                                    <el-form-item label="Kode Pos" prop="landlord_region_id">
                                        <el-select
                                            ref="landlord_region_id"
                                            name="landlord_region_id"
                                            class="width-100"
                                            clearable
                                            filterable
                                            remote
                                            :remote-method="getRegions"
                                            v-model="userForm.landlord_region_id"
                                            value-key="id"
                                            placeholder="Ketik kode pos"
                                            no-data-text="No Data"
                                            :loading="landlordRegionLoading">
                                            <el-option
                                                v-for="item in regions"
                                                :key="item.id"
                                                :label="item.name+' ('+item.postal+')'"
                                                :value="item.id">     
                                                <span style="float: left">{{ item.name }}</span>
                                                <strong style="float: right; color: #8492a6; font-size: 13px">{{ getAdministrative(item) }}</strong>                   
                                            </el-option>
                                        </el-select>
                                    </el-form-item>
                                </el-col>
                            </el-row>                    
                        </div>
                        <h3>Data Akun</h3>
                        <el-row :gutter="20">                    
                            <el-col :lg="8" :md="24" :sm="24">
                                <el-form-item label="Status Akun" prop="status">
                                    <el-select v-model="userForm.status" placeholder="Pilih status" class="width-100" ref="status" name="status">
                                        <el-option
                                            v-for="item in status"
                                            :key="item.value"
                                            :label="item.label"
                                            :value="item.value">
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="8" :md="24" :sm="24" v-if="me.role.slug == 'root' || userForm.id != me.id">
                                <el-form-item label="Role" prop="role">
                                    <el-select
                                        ref="role"
                                        name="role"
                                        class="width-100"
                                        v-model="userForm.role"
                                        value-key="id"
                                        placeholder="Pilih Role"
                                        no-data-text="No Data">
                                        <el-option
                                            v-for="item in userRoles"
                                            :key="item.id"
                                            :label="item.name"
                                            :value="item.id">                        
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="8" :md="24" :sm="24" v-if="me.role.slug == 'root'">
                                <el-form-item label="Sub Akun Dari" prop="parent">
                                    <el-select
                                        ref="parent"
                                        name="parent"
                                        class="width-100"
                                        v-model="userForm.parent"
                                        placeholder="Pilih Akun"
                                        no-data-text="No Data">
                                        <el-option
                                            v-for="item in parents"
                                            :key="item.id"
                                            :label="item.name"
                                            :value="item.id">                        
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>                    
                        </el-row> 
                    </el-tab-pane>
                    <el-tab-pane name="bank">
                        <span slot="label"><i class="ion-ios-square" style="color:#ED858A;"></i> Rekening Bank</span>
                        <h3>Rekening Bank</h3>
                        <div v-for="(accountItem, index) of userForm.bank_accounts" :key="index" class="dynamic-list">
                            <el-row :gutter="20">
                                <el-col :lg="12" :md="12" :sm="24">
                                    <el-form-item label="Bank" :prop="accountItem.bank_id != null ? accountItem.bank_id.toString() : accountItem.bank_id">
                                        <el-select
                                            ref="bank_id"
                                            name="bank_id"
                                            class="width-100"
                                            v-model="accountItem.bank_id"
                                            placeholder="Pilih Bank"
                                            no-data-text="No Data"
                                            filterable
                                            clearable>
                                            <el-option
                                                v-for="item in banks"
                                                :key="item.id"
                                                :label="item.name"
                                                :value="item.id">  
                                                <span style="float: left">{{ item.name }}</span>
                                                <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                        
                                            </el-option>
                                        </el-select>
                                    </el-form-item>
                                </el-col>
                                <el-col :lg="12" :md="12" :sm="24">
                                    <el-form-item label="Nama Akun Bank" :prop="accountItem.account_name">
                                        <el-input ref="account_name" name="account_name" v-model="accountItem.account_name" placeholder="Nama akun bank" autocomplete="off" maxlength="255" show-word-limit></el-input>
                                    </el-form-item>
                                </el-col>
                            </el-row>
                            <el-row :gutter="20">
                                <el-col :lg="12" :md="12" :sm="24">
                                    <el-form-item label="No. Rekening" :prop="accountItem.account_number">
                                        <el-input type="number" ref="account_number" name="account_number" v-model="accountItem.account_number" placeholder="No. Rekening bank" autocomplete="off" maxlength="255"></el-input>
                                    </el-form-item>
                                </el-col>
                                <el-col :lg="12" :md="12" :sm="24">
                                    <el-form-item label="Cabang" :prop="accountItem.branch">
                                        <el-input ref="branch" name="branch" v-model="accountItem.branch" placeholder="Nama kantor cabang/unit" autocomplete="off" maxlength="255" show-word-limit></el-input>
                                    </el-form-item>
                                </el-col>
                            </el-row>
                            <el-form-item label="Catatan" :prop="accountItem.description">
                                <el-input type="textarea" ref="description" name="description" v-model="accountItem.description" placeholder="Masukkan catatan" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                            </el-form-item>
                            <el-form-item>
                                <el-button class="float-right" @click="addBank" v-if="(index + 1) == userForm.bank_accounts.length" icon="el-icon-plus" type="success" size="mini"> Tambah</el-button>
                                <el-button class="float-right" @click="deleteBank(index)" v-else icon="el-icon-delete" type="danger" size="mini">Hapus </el-button>
                            </el-form-item>
                        </div>
                    </el-tab-pane>
                    <el-tab-pane name="store">
                        <span slot="label"><i class="ion-ios-square" style="color:#FACB8C;"></i> Toko</span>
                        <h3>Informasi Toko</h3>
                        <el-form-item label="Nama Toko" prop="store_name">
                            <el-input ref="store_name" name="store_name" v-model="userForm.store_name" placeholder="Nama toko" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                        <el-form-item label="Tentang Toko" prop="store_about">
                            <el-input type="textarea" ref="store_about" name="store_about" v-model="userForm.store_about" placeholder="Masukkan sekilas tentang toko" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                        </el-form-item>
                    </el-tab-pane>
                </el-tabs>                               
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'user', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import {gmapApi} from 'vue2-google-maps';
import moment from 'moment';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'User',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateAge = (rule, value, callback) => {
            const age = moment().diff(value, 'years');
            
            if(age < 10){
                return callback(new Error('Pengguna harus berusia minimal 10 tahun.'));
            }
            callback();
        };

        var validateIdcardNumber = (rule, value, callback) => {
            if(this.userForm.idcard != '' && value.trim().length == 0){
                return callback(new Error('No. Identitas wajib diisi.'))
            }
            callback();
        };

        var validateLandLord = (rule, value, callback) => {
            if(this.userForm.residential_status == 'rent' && value.trim().length == 0){
                return callback(new Error('Nama pemilik wajib diisi.'))
            }
            callback();
        };

        var validateLandLordPhone = (rule, value, callback) => {
            if(this.userForm.residential_status == 'rent' && value.trim().length == 0){
                return callback(new Error('No. Handphone pemilik wajib diisi.'))
            }
            callback();
        };

        var validateLandLordAddress = (rule, value, callback) => {
            if(this.userForm.residential_status == 'rent' && value.trim().length == 0){
                return callback(new Error('Alamat pemilik wajib diisi.'))
            }
            callback();
        };

        var validateLandLordRegion = (rule, value, callback) => {
            if(this.userForm.residential_status == 'rent' && value == ''){
                return callback(new Error('Alamat pemilik wajib diisi.'))
            }
            callback();
        };

        return {
            activeTab: 'profile',
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            parentLoading: false,
            profileRegionLoading: false,
            landlordRegionloading: false,
            filter: {
                keyword: '',
                status: '',
                parent: null,
                role: null,
                residential: null,
                online: false
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Pengguna',
                create: 'Tambah Pengguna'
            },
            status: [{
                label: 'Tidak Aktif',
                value: 'inactive'
            }, {
                label: 'Aktif',
                value: 'active'
            }, {
                label: 'Ditangguhkan',
                value: 'banned'
            }],
            residentialStatus: [{
                label: 'Pemilik',
                value: 'owner'
            }, {
                label: 'Sewa',
                value: 'rent'
            }, {
                label: 'Rumah Dinas',
                value: 'staffing'
            }],
            relationshipStatus: [{
                label: 'Suami',
                value: 'husband'
            }, {
                label: 'Istri',
                value: 'wife'
            }, {
                label: 'Anak',
                value: 'children'
            }, {
                label: 'Orang Tua',
                value: 'parents'
            }, {
                label: 'Saudara Kandung',
                value: 'sibling'
            }, {
                label: 'Sepupu',
                value: 'cousin'
            }, {
                label: 'Keponakan',
                value: 'nephew'
            }, {
                label: 'Asisten Rumah Tangga',
                value: 'assistant'
            }],
            showMap: false,
            map: {
                zoom: 14,
                center: {
                    lat: -2.9760735,
                    lng: 104.77543070000002
                }
            },
            userForm: {
                id: null,                
                birthday: new Date(),
                gender: '',                
                relationship_status: '',
                fullname: '',
                phone: '',
                idcard: '',
                idcard_number: '',
                address: '',
                profile_region_id: null,
                residential_status: '',
                residential: null,
                landlord_name: '',
                landlord_phone: '',
                landlord_address: '',
                landlord_region_id: null, 
                store_name: '',
                store_about: '',               
                status: '',
                role: null,
                parent: null,
                media: null,
                mediaURL: '',
                bank_accounts:[{
                    account_name: '',
                    account_number: '',
                    branch: '',
                    description: '',
                    bank_id: null
                }],
                latitude: null,
                longitude: null
            },
            userRules: {
                gender: [{
                    required: true, message: 'Silahkan pilih jenis kelamin', trigger: 'change'
                }],
                birthday: [{
                    validator: validateAge, trigger: 'change'
                }],
                relationship_status: [{
                    required: true, message: 'Silahkan pilih status pengguna di keluarga.', trigger: 'change'
                }],
                fullname: [{ 
                    required: true, message: 'Nama lengkap wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama lengkap maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                phone: [{
                    required: true, message: 'No. Handphone wajib diisi', trigger: 'blur'
                }, {
                    max: 25, message: 'No. Handphone maksimal 25 digit.', trigger: 'blur'
                }, {
                    pattern: /\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/, message: 'No. Handphone harus diawali dengan 08, +628 atau 628', trigger: 'blur'
                }],
                idcard: [{
                    required: true, message: 'Silahkan pilih jenis identitas.', trigger: 'change'
                }],
                idcard_number: [{
                    validator: validateIdcardNumber, trigger: 'blur'
                }, {
                    max: 45, message: 'No. Identitas maksimal 45 digit.', trigger: 'blur'
                }],
                address: [{
                    required: true, message: 'Alamat pengguna wajib diisi.', trigger: 'blur'
                }, {
                    max: 255, message: 'Alamat pengguna maksimal 255 karakter', trigger: 'blur'
                }],
                profile_region_id: [{
                    required: true, message: 'Kode pos wajib diisi.', trigger: 'change'
                }],
                residential_status: [{
                    required: true, message: 'Silahkan pilih status kepemilikan rumah.', trigger: 'change'
                }],
                landlord_name: [{
                    validator: validateLandLord, trigger: 'blur'
                },{
                    max: 255, message: 'Panjang nama pemilik maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                landlord_phone: [{
                    validator: validateLandLordPhone, trigger: 'blur'
                },{
                    max: 25, message: 'Panjang no. handphone pemilik maksimal 25 karakter', trigger: 'blur'
                }, {
                    pattern: /\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/, message: 'No. Handphone harus diawali dengan 08, +628 atau 628', trigger: 'blur'
                }],
                landlord_address: [{
                    validator: validateLandLordAddress, trigger: 'blur'
                }, {
                    max: 255, message: 'Alamat pemilik maksimal 255 karakter', trigger: 'blur'
                }],
                landlord_region_id: [{
                    validator: validateLandLordRegion, trigger: 'change'
                }],
                status: [{
                    required: true, message: 'Silahkan pilih status akun pengguna.', trigger: 'change'
                }],
                role: [{
                    required: true, message: 'Silahkan pilih role akun pengguna.', trigger: 'change'
                }],
                store_name: [{
                    max: 255, message: 'Nama toko maksimal 255 karakter', trigger: 'blur'
                }],
                store_about: [{
                    max: 255, message: 'Tentang toko maksimal 255 karakter', trigger: 'blur'
                }]

            },
            uploadURL: ''
        };
    },
    computed: {
        tableHeight,
        google: gmapApi,
        ...mapGetters('role', ['roles']),
        ...mapGetters('region', ['regions']),
        ...mapGetters('auth', ['token']),
        ...mapGetters('bank', ['banks']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('user', [
            'me',
            'users',
            'parents',
            'pagination'
        ]),
        userRoles: function(){
            if(this.me.role.slug === 'root'){
                return this.roles;
            }else{
                return this.roles.filter((x) => ['orphan', 'root', 'owner'].indexOf(x.slug) === -1);
            }
        }
    },
    created() {
        this.getUsers();
        this.getRoles();
        this.getBanks();
        this.getResidentials();
    },
    methods: {
        playSound,
        dateFormat,
        isNumeric(n) {
            return !isNaN(parseFloat(n)) && isFinite(n);
        },
        getAdministrative(region, level){
            var temp = [];
            level = level || 0;

            if(region.parents){
                temp.push(region.name);
                level++;
                temp.push.apply(temp, this.getAdministrative(region.parents, level));
            }else{
                temp.push(region.name);
            }

            if(temp.length == 4){
                temp.splice(0,2);
                return temp.join(', ');
            }
            
            return temp;
        },
        getUsers() {
            this.tableLoading = true;
            this.$store.dispatch('user/getUsers', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getParents(q) {        
            if(q.length >= 3){
                this.parentLoading = true;
                this.$store.dispatch('user/getParents', {
                    q: q,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.parentLoading = false;
                });
            }
        },
        getRoles() {
            this.tableLoading = true;
            this.$store.dispatch('role/getAllRoles', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getRegions(q) {
            if(q.length >= 3 && this.isNumeric(q)){
                this.billingRegionLoading = true;
                this.$store.dispatch('region/getRegions', {
                    q: q,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.billingRegionLoading = false;
                });
            }
        },
        getBanks() {
            this.tableLoading = true;
            this.$store.dispatch('bank/getBanks', {
                page: this.pagination.page,
                perpage: 100
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: 100
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.status != ''){
                payload['status'] = this.filter.status;
            }

            if(this.filter.role != null){
                payload['role'] = this.filter.role;
            }

            if(this.filter.parent != null){
                payload['parent'] = this.filter.parent;
            }

            this.tableLoading = true;
            this.$store.dispatch('user/getUsers', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleMoveMarker(e){
            this.userForm.latitude = e.latLng.lat();
            this.userForm.longitude = e.latLng.lng();

            var self = this;

            setTimeout(() => {
                self.$refs.mapRef.$mapPromise.then((map) => {
                    map.setZoom(18);
                    map.panTo({lat: e.latLng.lat(), lng: e.latLng.lng()});
                });
            }, 100);
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;
            this.uploadURL = 'http://api.ringsatu.id/v1/media/tmp';     
            
            if(['root', 'owner'].indexOf(this.me.role.slug) == -1){
                this.userForm.residential = this.me.residential.id
            }

            this.$nextTick(() => {
                this.$refs['userForm'].clearValidate();
            });
        },
        handleEdit(user){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.uploadURL = 'http://api.ringsatu.id/v1/media/profile/'+user.profile.id
            this.userForm.id = user.id;
            this.userForm.media = user.profile.media != null ? user.profile.media.id : null;
            this.userForm.gender = user.profile.gender;
            this.userForm.birthday = user.profile.birthday;  
            this.userForm.fullname = user.profile.fullname;
            this.userForm.phone = user.profile.phone;
            this.userForm.idcard = user.profile.idcard;
            this.userForm.idcard_number = user.profile.idcard_number;
            this.userForm.address = user.profile.address;
            this.userForm.profile_region_id = user.profile.profile_region_id;
            this.userForm.residential_status = user.profile.residential_status;
            this.userForm.landlord_name = user.profile.landlord_name;
            this.userForm.landlord_address = user.profile.landlord_address;
            this.userForm.landlord_phone = user.profile.landlord_phone;
            this.userForm.landlord_region_id = user.profile.landlord_region_id;
            this.userForm.store_name = user.profile.store_name;
            this.userForm.store_about = user.profile.store_about;
            this.userForm.relationship_status = user.relationship_status;
            this.userForm.role = user.role.id;
            this.userForm.status = user.status;
            this.userForm.parent = user.parent_id;
            this.userForm.residential = user.residential.id;
            this.userForm.mediaURL = user.profile.media ? user.profile.media.url.large : '';
            this.userForm.latitude = user.profile.latitude;
            this.userForm.longitude = user.profile.longitude;
            this.getRegions(user.profile.profile_region[4]);

            if(user.profile.landlord_region_id != null){
                this.getRegions(user.profile.landlord_region_id[4]);
            }

            if(user.bank_accounts){
                this.userForm.bank_accounts = user.bank_accounts.filter((x) => {
                    return {
                        account_name: x.account_name,
                        account_number: x.account_number,
                        bank_id: x.bank_id,
                        branch: x.branch,
                        description: x.description
                    }
                });
            }

            if(user.profile.latitude && user.profile.longitude){
                this.showMap = true;
                this.map.center.lat = user.profile.latitude;
                this.map.center.lng = user.profile.longitude;

                var self = this;

                setTimeout(() => {
                    self.$refs.mapRef.$mapPromise.then((map) => {
                        map.setZoom(18);
                        map.panTo(self.map.center);
                    });
                }, 100);
            }

            this.$nextTick(() => {
                this.$refs['userForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.userForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'user/addUser';
                        payload = {
                            media: this.userForm.media,
                            gender: this.userForm.gender,
                            birthday: this.userForm.birthday,  
                            fullname: this.userForm.fullname,
                            phone: this.userForm.phone,
                            idcard: this.userForm.idcard,
                            idcard_number: this.userForm.idcard_number,
                            address: this.userForm.address,
                            profile_region_id: this.userForm.profile_region_id,
                            residential_status: this.userForm.residential_status,
                            landlord_name: this.userForm.landlord_name,
                            landlord_address: this.userForm.landlord_address,
                            landlord_phone: this.userForm.landlord_phone,
                            store_name: this.userForm.store_name,
                            store_about: this.userForm.store_about,
                            relationship_status: this.userForm.relationship_status,
                            role: this.userForm.role,
                            status: this.userForm.status,
                            parent: this.userForm.parent,
                            residential: this.userForm.residential,
                            bank_accounts: this.userForm.bank_accounts,
                            latitude: this.userForm.latitude,
                            longitude: this.userForm.longitude
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'user/editUser';
                        payload = {
                            id: this.userForm.id,
                            media: this.userForm.media,
                            gender: this.userForm.gender,
                            birthday: this.userForm.birthday,  
                            fullname: this.userForm.fullname,
                            phone: this.userForm.phone,
                            idcard: this.userForm.idcard,
                            idcard_number: this.userForm.idcard_number,
                            address: this.userForm.address,
                            profile_region_id: this.userForm.profile_region_id,
                            residential_status: this.userForm.residential_status,
                            landlord_name: this.userForm.landlord_name,
                            landlord_address: this.userForm.landlord_address,
                            landlord_phone: this.userForm.landlord_phone,
                            store_name: this.userForm.store_name,
                            store_about: this.userForm.store_about,
                            relationship_status: this.userForm.relationship_status,
                            role: this.userForm.role,
                            status: this.userForm.status,
                            parent: this.userForm.parent,
                            residential: this.userForm.residential,
                            bank_accounts: this.userForm.bank_accounts,
                            latitude: this.userForm.latitude,
                            longitude: this.userForm.longitude
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;
                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(user){
            this.$confirm('Anda mencoba untuk menghapus data pengguna, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('user/deleteUser', {
                    id: user.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.userForm = {
                id: null,                
                birthday: new Date(),
                gender: '',                
                relationship_status: '',
                fullname: '',
                phone: '',
                idcard: '',
                idcard_number: '',
                address: '',
                profile_region_id: null,
                residential_status: '',
                residential: null,
                landlord_name: '',
                landlord_phone: '',
                landlord_address: '',
                landlord_region_id: null,     
                store_name: '',
                store_about: '',           
                status: '',
                role: null,
                parent: null,
                media: null,
                mediaURL: '',
                bank_accounts:[{
                    account_name: '',
                    account_number: '',
                    branch: '',
                    description: '',
                    bank_id: null
                }]
            }
            this.activeTab = 'profile';
        },
        handleAvatarSuccess(res) {
            this.userForm.media = res.data.media.id;
            this.userForm.mediaURL = res.data.media.url.original;
        },
        beforeAvatarUpload(file) {
            if (['image/jpeg', 'image/png'].indexOf(file.type) < 0) {
                this.$message.error('Hanya image dengan tipe file JPG/JPEG dan PNG yang diperbolehkan.');
                return false;
            }
            if (file.size > (8 * 1024 * 1024)) {
                this.$message.error('Ukuran file tidak boleh lebih dari 8MB.');
                return false;
            }
            return true;
        },
        handleRemove(){
            let action = '';
            let params = {};

            if(this.dialogStatus == 'create'){
                action = 'media/deleteMediaTmp';
                params.id = this.userForm.media;
            }else{
                action = 'media/deleteMedia';
                params.id = this.userForm.media;
                params.endpoint = 'profile';
            }

            this.$store.dispatch(action, params).then((response) => {
                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    this.userForm.mediaURL = null;
                    this.$message.success({
                        message: response.message
                    });
                }

                this.playSound();
            });
        },
        addBank() {
            this.userForm.bank_accounts.push({
                account_name: '',
                account_number: '',
                branch: '',
                description: '',
                bank_id: ''
            });
        },
        deleteBank(index) {
            for(const [i, v] of this.userForm.bank_accounts.entries()){
                if(i == index){
                    this.userForm.bank_accounts.splice(i, 1);                    
                    break;
                }
            }
        }
    }

}
</script>
<style>
    #map{
        width: 100%;
        height: 400px;
    }
</style>